#!/usr/bin/env python
#
#     Copyright (C) 2002 Stas Z <stas@linux.isbeter.nl>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

"""#########################################################################
 letters-trans.py - A script to translate the words used by the letters game 
 into your own language. (about 12 words)
 I'm always looking for people who wants to translate a few small text files
 into there own langauge.
 This is your change to do something back to the open-source community!
 Contact stas Z at childsplay@users.sourceforge.net.
 
  *****************************************************************
  If you want to quit, or don't want to change anything, type Q [enter].
  *****************************************************************
  """
FILEHEADER = "# This is a file generated by childsplay\n# Use letters-trans.py to generate a new one" 

import os,fnmatch,operator,sys
try:
    import pyassetml
except ImportError,info:
    print >> sys.stderr,info,"\n\n This version of childsplay depends on pyassetml"
    print >> sys.stderr, "\n You can get the pyassetml package at:","\n http://www.ofset.org/assetml"
    sys.exit(1)

if len(sys.argv) > 1:
    cwd = sys.argv[1]
else:
    print 'Usage, letters-trans.py path-to-childsplay'
    raise SystemExit

basedir = os.path.join(cwd,'lib','LettersData')
if not os.path.exists(basedir):
    try:
        os.mkdir(basedir)
    except OSError,info:
        print info
        raise SystemExit

def savefile(file):
    print "Installing translation file..."
    try:
        f=open(os.path.join(basedir,'word-translations'),'w')
        f.writelines(file)
        f.close()
    except OSError,info:
        print >> sys.stderr,'ERROR in creating letter translation file ',info
        f.close() # to be save
        raise SystemExit

# get description names from memory assetml, these are the words used by letters.py
parser = pyassetml.AssetmlParser('childsplay/memory-136x136/memory-136x136.assetml')
loc = parser.get_locale()# get current locale setting, only the first two chars !!
wlist_org = parser.find_names((('file','.'),('description',"en")))
wlist = parser.find_names((('file','.'),('description',loc)))
file = [FILEHEADER]
#print wlist_org
#print wlist
if wlist:
    print "Already have translations in your language"
    for word,trans in map(None, wlist_org, wlist):
        file.append("%s=%s\n" % (word.lower(),trans.lower()))
    savefile(file)

else:
    print __doc__
    for word in wlist_org:
        prompt = 'Give the translation off: '+word+' ,or Q to quit -> '
        trans = raw_input(prompt)
        if trans == '':
            continue
        elif trans == 'Q':
            break
        file.append("%s=%s\n" % (word,trans))
    else:
        savefile(file)

print " That's all, enjoy"
sys.exit(0)

